Index: code/branches/gui/src/orxonox/gamestates/GSClient.cc
===================================================================
--- code/branches/gui/src/orxonox/gamestates/GSClient.cc	(revision 2799)
+++ code/branches/gui/src/orxonox/gamestates/GSClient.cc	(revision 2800)
@@ -31,4 +31,5 @@
 
 #include "core/input/InputManager.h"
+#include "core/Clock.h"
 #include "core/CommandLine.h"
 #include "core/Core.h"
@@ -60,5 +61,6 @@
         GSLevel::enter(this->getParent()->getViewport());
 
-        client_->tick(0);
+        // TODO: Get Clock from Game or GameStateManager, but with 0 delta time
+        client_->update(Clock());
     }
 
@@ -78,5 +80,5 @@
     {
         GSLevel::ticked(time);
-        client_->tick(time.getDeltaTime());
+        client_->update(time);
 
         this->tickChild(time);
Index: code/branches/gui/src/orxonox/gamestates/GSDedicated.cc
===================================================================
--- code/branches/gui/src/orxonox/gamestates/GSDedicated.cc	(revision 2799)
+++ code/branches/gui/src/orxonox/gamestates/GSDedicated.cc	(revision 2800)
@@ -30,4 +30,5 @@
 #include "GSDedicated.h"
 
+#include "core/Clock.h"
 #include "core/CommandLine.h"
 #include "core/Core.h"
@@ -83,5 +84,5 @@
             timeSinceLastUpdate_ -= static_cast<unsigned int>(timeSinceLastUpdate_ / NETWORK_PERIOD) * NETWORK_PERIOD;
             GSLevel::ticked(time);
-            server_->tick(time.getDeltaTime());
+            server_->update(time);
             this->tickChild(time);
         }
Index: code/branches/gui/src/orxonox/gamestates/GSGUI.cc
===================================================================
--- code/branches/gui/src/orxonox/gamestates/GSGUI.cc	(revision 2799)
+++ code/branches/gui/src/orxonox/gamestates/GSGUI.cc	(revision 2800)
@@ -31,4 +31,5 @@
 
 #include <OgreViewport.h>
+#include "core/Clock.h"
 #include "core/input/InputManager.h"
 #include "core/input/SimpleInputState.h"
@@ -64,5 +65,5 @@
     {
         // tick CEGUI
-        guiManager_->tick(time.getDeltaTime());
+        guiManager_->update(time);
 
         this->tickChild(time);
Index: code/branches/gui/src/orxonox/gamestates/GSGraphics.cc
===================================================================
--- code/branches/gui/src/orxonox/gamestates/GSGraphics.cc	(revision 2799)
+++ code/branches/gui/src/orxonox/gamestates/GSGraphics.cc	(revision 2800)
@@ -233,7 +233,7 @@
         float dt = time.getDeltaTime();
 
-        this->inputManager_->tick(dt);
+        this->inputManager_->update(time);
         // tick console
-        this->console_->tick(dt);
+        this->console_->update(time);
         this->tickChild(time);
 
Index: code/branches/gui/src/orxonox/gamestates/GSRoot.cc
===================================================================
--- code/branches/gui/src/orxonox/gamestates/GSRoot.cc	(revision 2799)
+++ code/branches/gui/src/orxonox/gamestates/GSRoot.cc	(revision 2800)
@@ -134,5 +134,5 @@
         uint64_t timeBeforeTick = time.getRealMicroseconds();
 
-        Core::getInstance().tick(time);
+        Core::getInstance().update(time);
 
         for (ObjectList<TimerBase>::iterator it = ObjectList<TimerBase>::begin(); it; ++it)
Index: code/branches/gui/src/orxonox/gamestates/GSServer.cc
===================================================================
--- code/branches/gui/src/orxonox/gamestates/GSServer.cc	(revision 2799)
+++ code/branches/gui/src/orxonox/gamestates/GSServer.cc	(revision 2800)
@@ -73,5 +73,5 @@
     {
         GSLevel::ticked(time);
-        server_->tick(time.getDeltaTime());
+        server_->update(time);
         this->tickChild(time);
     }
Index: code/branches/gui/src/orxonox/gamestates/GSStandalone.cc
===================================================================
--- code/branches/gui/src/orxonox/gamestates/GSStandalone.cc	(revision 2799)
+++ code/branches/gui/src/orxonox/gamestates/GSStandalone.cc	(revision 2800)
@@ -86,5 +86,5 @@
         }
         // tick CEGUI
-        guiManager_->tick(time.getDeltaTime());
+        guiManager_->update(time);
 
         GSLevel::ticked(time);